=== mcs/class/Microsoft.VisualC/Makefile ===
thisdir = class/Microsoft.VisualC
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.VisualC.dll
LIB_REFS = System
KEYFILE = ../msfinal.pub

NO_TEST = yes

include ../../build/library.make
