=== mcs/class/Mono.CodeContracts/Makefile ===
thisdir = class/Mono.CodeContracts
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.CodeContracts.dll

LIB_REFS = System System.Core Mono.Cecil Mono.Cecil.Mdb
KEYFILE = ../mono.pub
LIB_MCS_FLAGS = -nowarn:618

TEST_MCS_FLAGS =
TEST_LIB_REFS = System.Core

include ../../build/library.make
