=== mcs/class/Mono.Simd/Makefile ===
thisdir = class/Mono.Simd
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.Simd.dll
LIB_REFS = System.Core
KEYFILE = ../mono.pub
LIB_MCS_FLAGS = /unsafe

NO_TEST = yes

include ../../build/library.make
