=== debian/changelog ===
mono (6.14.1+ds-2) unstable; urgency=medium

  * Add missing authors in debian/copyright.
  * Update packages descriptions.

 -- Antoine Le Gonidec <vv221@debian.org>  Wed, 13 Aug 2025 15:33:21 +0200

mono (6.14.1+ds-1) unstable; urgency=medium

  * Switch to new WineHQ upstream.
    (Closes: #1092582)
  * New ustream release.
  * Stop listing symbols for libmonosgen-2.0.so.1.

 -- Antoine Le Gonidec <vv221@debian.org>  Wed, 13 Aug 2025 13:11:22 +0200
