=== debian/control ===
Source: mono
Section: cli-mono
Priority: optional
Maintainer: Antoine Le Gonidec <vv221@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.16.1~),
               bison,
               cmake,
               dc,
               libkrb5-dev,
               libx11-dev,
               libxml-dom-perl,
               libxslt1-dev,
               libxt-dev,
               lsb-release,
               procps,
               python3,
               tzdata,
               zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: http://www.mono-project.com/
Vcs-Git: https://salsa.debian.org/dotnet-team/mono.git
Vcs-Browser: https://salsa.debian.org/dotnet-team/mono

Package: mono-runtime-common
Provides: cli-runtime, cli-virtual-machine
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: libmono0 (<< 2.4),
          mono-common (<< 2.4),
          mono-jit (<< 2.4),
          mono-runtime (<< 3.2.1)
Conflicts: mono-1.0-runtime (<< 2.4),
           mono-2.0-runtime (<< 2.4),
           mono-common (<< 2.4),
           mono-jit (<< 2.4),
           mono-runtime (<< 3.2.1)
Suggests: xdg-utils | libgnome2-0 | konqueror
Depends: binutils, ${misc:Depends}, ${shlibs:Depends}
Description: Mono runtime - common files
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains common files for the Virtual Machine, JIT (Just-in-Time)
 and AOT (Ahead-of-Time) code generator "mono".
 "mono" executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures. Optionally this package configures BINFMT support.

Package: mono-runtime
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmono-corlib4.5-cil,
         mono-runtime-sgen (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: binfmt-support (>= 1.1.2)
Description: Mono runtime - default version
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package installs this architecture's default runtime version.

Package: mono-runtime-sgen
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: mono-gac (= ${source:Version}),
         mono-runtime-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Homepage: http://www.mono-project.com/Compacting_GC
Description: Mono runtime - Using SGen garbage collector
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses SGen which is Mono's new simple generational garbage
 collector.

Package: mono-runtime-boehm
Architecture: amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: mono-gac (= ${source:Version}),
         mono-runtime-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mono runtime - Using Boehm's garbage collector
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses Boehm's conservative garbage collector.

Package: mono-runtime-dbg
Priority: optional
Section: debug
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: mono-jit-dbg (<< 2.4)
Conflicts: mono-jit-dbg (<< 2.4)
Depends: mono-runtime-boehm (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
         mono-runtime-sgen (= ${binary:Version}),
         ${misc:Depends}
Recommends: gdb
Description: Mono runtime, debugging symbols
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the debugging symbols of the Mono JIT/AOT compiler.

Package: mono-utils
Provides: cil-disassembler
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: mono-mcs (<= 1.1.6-4)
Depends: libmono-corlib4.5-cil (= ${source:Version}),
         libmonoboehm-2.0-1 (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mono utilities
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package includes various tools useful for CLI developers, like
 pedump, monodis and monograph.

Package: ca-certificates-mono
Architecture: all
Pre-Depends: mono-runtime-common (>= 5.20)
Depends: ca-certificates (>= 20121114),
         ${cli:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Common CA certificates (Mono keystore)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package uses the hooks of the ca-certificates package to update the
 Mono keystore.

Package: mono-complete
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: ca-certificates-mono (= ${source:Version}),
         libmono-2.0-1 (= ${binary:Version}),
         libmono-cil-dev (= ${source:Version}),
         libmono-profiler (= ${binary:Version}),
         mono-4.0-gac (= ${source:Version}),
         mono-4.0-service (= ${source:Version}),
         mono-csharp-shell (= ${source:Version}),
         mono-devel (= ${source:Version}),
         mono-mcs (= ${source:Version}),
         mono-runtime (= ${binary:Version}),
         mono-runtime-sgen (= ${binary:Version}),
         mono-utils (= ${binary:Version}),
         monodoc-base (= ${source:Version}),
         monodoc-manual (= ${source:Version}),
         ${misc:Depends}
Description: complete Mono runtime, development tools and all libraries
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This is a metapackage and pulls in the Mono runtime, development tools and
 all libraries.
 .
 Install this package if you want to run software for Mono or Microsoft .NET
 which you are not installing from a Debian package.
 .
 For packagers: This package is not to be used as dependency for packages!
 You should build-depend on cli-common-dev and the needed libraries instead.

Package: libmono-2.0-1
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: libmono-dev (<= 1.1.6-4)
Conflicts: mono-utils (<< 1.2.3.1-4)
Depends: libmonosgen-2.0-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mono JIT library (Default version)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Shared library for Mono, used for embedding/hosting of the JIT.

Package: libmono-2.0-dev
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmonosgen-2.0-dev (= ${binary:Version}), ${misc:Depends}
Description: Mono JIT library - Development files (Default version)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Header files and static libraries for libmono-2.0.

Package: libmonosgen-2.0-1
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Mono JIT library (SGen GC)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Shared library for Mono, used for embedding/hosting of the JIT.

Package: libmonosgen-2.0-1-dbg
Priority: optional
Section: debug
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmonosgen-2.0-1 (= ${binary:Version}), ${misc:Depends}
Recommends: gdb
Description: Mono JIT library, debugging symbols (SGen GC)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the debugging symbols of the Mono JIT library.

Package: libmonosgen-2.0-dev
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmonosgen-2.0-1 (= ${binary:Version}), ${misc:Depends}
Description: Mono JIT library - Development files (SGen GC)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Header files and static libraries for libmonosgen-2.0.

Package: libmonoboehm-2.0-1
Architecture: amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Mono JIT library (Boehm GC)
 Framework Mono is a software platform designed to allow developers to easily
