=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds//,repacksuffix=+ds,compression=xz \
	https://dl.winehq.org/mono/sources/mono/mono-([\d\.]+)\.tar\.xz
